<html>
<head>
<title>OgreD3D9HardwareVertexBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_c7ffc14721c8bed1493f4f78ca8c7331.html">Direct3D9</a>      </li>
      <li class="navelem"><a class="el" href="dir_1208738e8444befc5f502320df40a1ea.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D9HardwareVertexBuffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D9HardwareVertexBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D9HARDWAREVERTEXBUFFER_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D9HARDWAREVERTEXBUFFER_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Prerequisites_8h.html">OgreD3D9Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Resource_8h.html">OgreD3D9Resource.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00038"></a><a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html">00038</a>     <span class="keyword">class </span><a class="code" href="OgreD3D9Prerequisites_8h.html#a2f097a9b4c2ebfb75896e7d6eec01a1d">_OgreD3D9Export</a> <a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html" title="Specialisation of HardwareVertexBuffer for D3D9.">D3D9HardwareVertexBuffer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1D3D9Resource.html" title="Represents a Direct3D rendering resource.">D3D9Resource</a>
<a name="l00039"></a>00039     {   
<a name="l00040"></a>00040 
<a name="l00041"></a>00041     <span class="keyword">public</span>:
<a name="l00042"></a>00042         <a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html" title="Specialisation of HardwareVertexBuffer for D3D9.">D3D9HardwareVertexBuffer</a>(<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* mgr, <span class="keywordtype">size_t</span> vertexSize, 
<a name="l00043"></a>00043             <span class="keywordtype">size_t</span> numVertices, <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> useSystemMem, <span class="keywordtype">bool</span> useShadowBuffer);
<a name="l00044"></a>00044         ~<a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html" title="Specialisation of HardwareVertexBuffer for D3D9.">D3D9HardwareVertexBuffer</a>();
<a name="l00046"></a>00046         <span class="keywordtype">void</span> readData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keywordtype">void</span>* pDest);
<a name="l00048"></a>00048         <span class="keywordtype">void</span> writeData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keyword">const</span> <span class="keywordtype">void</span>* pSource,
<a name="l00049"></a>00049                 <span class="keywordtype">bool</span> discardWholeBuffer = <span class="keyword">false</span>);
<a name="l00050"></a>00050     
<a name="l00051"></a>00051         <span class="comment">// Called immediately after the Direct3D device has been created.</span>
<a name="l00052"></a>00052         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceCreate(IDirect3DDevice9* d3d9Device);
<a name="l00053"></a>00053 
<a name="l00054"></a>00054         <span class="comment">// Called before the Direct3D device is going to be destroyed.</span>
<a name="l00055"></a>00055         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceDestroy(IDirect3DDevice9* d3d9Device);
<a name="l00056"></a>00056 
<a name="l00057"></a>00057         <span class="comment">// Called immediately after the Direct3D device has entered a lost state.</span>
<a name="l00058"></a>00058         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceLost(IDirect3DDevice9* d3d9Device);
<a name="l00059"></a>00059 
<a name="l00060"></a>00060         <span class="comment">// Called immediately after the Direct3D device has been reset</span>
<a name="l00061"></a>00061         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceReset(IDirect3DDevice9* d3d9Device);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063         <span class="comment">// Create the actual vertex buffer.</span>
<a name="l00064"></a>00064         <span class="keywordtype">void</span> createBuffer(IDirect3DDevice9* d3d9Device, D3DPOOL ePool);
<a name="l00065"></a>00065         
<a name="l00067"></a>00067         IDirect3DVertexBuffer9* getD3D9VertexBuffer(<span class="keywordtype">void</span>);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069     <span class="keyword">protected</span>:  
<a name="l00070"></a><a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html">00070</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html">BufferResources</a>
<a name="l00071"></a>00071         {
<a name="l00072"></a><a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#adcee1fdd66c27c74f09e7845e1a31dea">00072</a>             IDirect3DVertexBuffer9*     <a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#adcee1fdd66c27c74f09e7845e1a31dea">mBuffer</a>;
<a name="l00073"></a><a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#acdea58691039d6cdd31bf14ec5164a85">00073</a>             <span class="keywordtype">bool</span>                        <a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#acdea58691039d6cdd31bf14ec5164a85">mOutOfDate</a>;
<a name="l00074"></a><a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#a5658c768cc185b7f5121347b886b2e2c">00074</a>             <span class="keywordtype">size_t</span>                      <a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#a5658c768cc185b7f5121347b886b2e2c">mLockOffset</a>;
<a name="l00075"></a><a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#a8b570d4bda57b6ea5eb4259e9d5c373e">00075</a>             <span class="keywordtype">size_t</span>                      <a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#a8b570d4bda57b6ea5eb4259e9d5c373e">mLockLength</a>;
<a name="l00076"></a><a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#a3fc3530fd30c3e5e2b38b0ec4907317b">00076</a>             <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a>                 <a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#a3fc3530fd30c3e5e2b38b0ec4907317b">mLockOptions</a>;
<a name="l00077"></a><a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#a761a4f076f6b67ba612aed1466efa5f7">00077</a>             <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>                        <a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html#a761a4f076f6b67ba612aed1466efa5f7">mLastUsedFrame</a>;
<a name="l00078"></a>00078         };
<a name="l00079"></a>00079 
<a name="l00080"></a>00080     <span class="keyword">protected</span>:      
<a name="l00082"></a>00082         <span class="keywordtype">void</span>* lockImpl(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);      
<a name="l00083"></a>00083         
<a name="l00085"></a>00085         <span class="keywordtype">void</span> unlockImpl(<span class="keywordtype">void</span>);          
<a name="l00086"></a>00086         
<a name="l00088"></a>00088         <span class="keywordtype">void</span> updateBufferContent(<a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html">BufferResources</a>* bufferResources);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090         <span class="comment">// updates buffer resources from system memory buffer.</span>
<a name="l00091"></a>00091         <span class="keywordtype">bool</span> updateBufferResources(<span class="keyword">const</span> <span class="keywordtype">char</span>* systemMemoryBuffer, <a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html">BufferResources</a>* bufferResources);       
<a name="l00092"></a>00092 
<a name="l00094"></a>00094         <span class="keywordtype">char</span>* _lockBuffer(<a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html">BufferResources</a>* bufferResources, <span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length);
<a name="l00095"></a>00095 
<a name="l00097"></a>00097         <span class="keywordtype">void</span> _unlockBuffer(<a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html">BufferResources</a>* bufferResources);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     <span class="keyword">protected</span>:
<a name="l00101"></a><a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#adb580f458f63ac5ae45e82dec660506b">00101</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;IDirect3DDevice9*, BufferResources*&gt;::type</a>  <a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#adb580f458f63ac5ae45e82dec660506b">DeviceToBufferResourcesMap</a>;
<a name="l00102"></a><a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#ad67074cee29a2368f350e4f51c667ca6">00102</a>         <span class="keyword">typedef</span> DeviceToBufferResourcesMap::iterator            <a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#ad67074cee29a2368f350e4f51c667ca6">DeviceToBufferResourcesIterator</a>;
<a name="l00103"></a>00103 
<a name="l00104"></a><a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#adadc64646d511172d27e48f4391a05d1">00104</a>         <a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#adb580f458f63ac5ae45e82dec660506b">DeviceToBufferResourcesMap</a>  <a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#adadc64646d511172d27e48f4391a05d1">mMapDeviceToBufferResources</a>;    <span class="comment">// Map between device to buffer resources.</span>
<a name="l00105"></a><a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#a46f0e3123b412ebb1fa2c003e6de73a3">00105</a>         D3DVERTEXBUFFER_DESC        <a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#a46f0e3123b412ebb1fa2c003e6de73a3">mBufferDesc</a>;                    <span class="comment">// Buffer description.      </span>
<a name="l00106"></a><a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#aefac7c2ec610b49c3cc54f9f4e7f4de5">00106</a>         <a class="code" href="structOgre_1_1D3D9HardwareVertexBuffer_1_1BufferResources.html">BufferResources</a>*            <a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#aefac7c2ec610b49c3cc54f9f4e7f4de5">mSourceBuffer</a>;                  <span class="comment">// Source buffer resources when working with multiple devices.</span>
<a name="l00107"></a><a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#ab4ef1067f7fc1f81d2167a695d81dd87">00107</a>         <span class="keywordtype">char</span>*                       <a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#ab4ef1067f7fc1f81d2167a695d81dd87">mSourceLockedBytes</a>;             <span class="comment">// Source buffer locked bytes.</span>
<a name="l00108"></a><a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#acab97739a1e1c1a55a646c02fa63b365">00108</a>         <span class="keywordtype">char</span>*                       <a class="code" href="classOgre_1_1D3D9HardwareVertexBuffer.html#acab97739a1e1c1a55a646c02fa63b365">mSystemMemoryBuffer</a>;            <span class="comment">// Consistent system memory buffer for multiple devices support in case of write only buffers.</span>
<a name="l00109"></a>00109     };
<a name="l00110"></a>00110 }
<a name="l00111"></a>00111 <span class="preprocessor">#endif</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
